﻿using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Razor.TagHelpers;
using System.Text;

namespace TagHelpersTutorial.Helpers
{
   
    public class Carousel : TagHelper
    {
       public string Id { get; set; }
       public long Interval { get; set; } = 3000;
       public List<string> ImageSource { get; set; } = null;

        //Write code for creating required result from TagHelper
        public override void Process(TagHelperContext context, TagHelperOutput output)
        {
            output.TagName = "";
            var sb = new StringBuilder();
            if (ImageSource != null && ImageSource.Count > 0)
            {                
                //Opening tag of carousel div and images Links
                string strOpen = string.Format(@"<div id = ""{0}"" class=""carousel slide"" data-ride=""s"" data-interval=""{1}"">
            <ol class=""carousel-indicators"">", Id, Interval);
             
                //Creating dynamic code for images links and carousel items images
                string strListItem = "";
               
                //opening tag of carousel items images                
                string strImageOpen = @"<div class=""carousel-inner"" role=""listbox"">";
                string strImage = "";
                for (int i = 0; i < ImageSource.Count; i++)
                {
                    //add images links and carousel item images with active class for first image
                    if (i == 0)
                    {
                        //add images links with active class for first image
                        strListItem += string.Format(@"<li data-target=""#{0}"" data-slide-to=""{1}"" class=""active""></li>", Id, i);
                        //add carousel item images with active class for first image
                        strImage += string.Format(@"<div class=""item active"">
                                    <img src = ""{0}"" alt=""{1}"" class=""img-responsive""/>                    
                                    </div>", ImageSource[i], "");
                    }
                    //add images links and carousel item images
                    else
                    {
                        //add images links
                        strListItem += string.Format(@"<li data-target=""#{0}"" data-slide-to=""{1}""></li>", Id, i);
                        //add carousel item images
                        strImage += string.Format(@"<div class=""item"">
                                    <img src = ""{0}"" alt=""{1}"" class=""img-responsive""/>                    
                                    </div>", ImageSource[i], "");
                    }
                }
                //closing tag of images links
                string strClose = "</ol>";

                //closing tag of carousel items images
                string strImageClose = "</div>";
                
                //code for carousel buttons
                string strButton = string.Format(
                    @"
                    <a class=""left carousel-control"" href=""#{0}"" role=""button"" data-slide=""prev"">
                        <span class=""glyphicon glyphicon-chevron-left"" aria-hidden=""true""></span>
                        <span class=""sr-only"">Previous</span>
                    </a>
                    <a class=""right carousel-control"" href=""#{1}"" role=""button"" data-slide=""next"">
                        <span class=""glyphicon glyphicon-chevron-right"" aria-hidden=""true""></span>
                        <span class=""sr-only"">Next</span>
                    </a>
                    </div>", Id, Id);

                sb.Append(strOpen);
                sb.Append(strListItem);
                sb.Append(strClose);
                sb.Append(strImageOpen);
                sb.Append(strImage);
                sb.Append(strImageClose);
                sb.Append(strButton);
            }
            else
                throw new ArgumentException("ImageSource can't be empty or null.");
            //Add HTML code to output
            output.Content.AppendHtml(sb.ToString());
        }
    }
}
