﻿using System;
using System.Collections.Generic;
using TagHelpersTutorial.Services;
using System.Linq;
using System.Threading.Tasks;

namespace TagHelpersTutorial.Models
{

    public class DataModel
    {
      
        public Languages Lang { get { return new Languages(); }  }

        public CustomImages ImageSource { get { return new CustomImages(); } }

        public UserLogin Users { get; set; }

        public Contacts Contact { get { return new Contacts(); } }
        
    }
    public class UserLogin
    {
        /// <summary>
        /// Gets or Sets the Email Address
        /// </summary>
        public string UserId { get; set; } 

        /// <summary>
        /// Gets or Sets the Password
        /// </summary>
        public string Password { get; set; } 

            
       
    }
    public class Languages
    {
        public List<string> LanguageList { get; set; }

        public Languages()
        {
            GetData data = new GetData();
            LanguageList = data.GetLanguagesList();
           
        }
    }

    public class CustomImages
    {
        public List<string> ImageList { get; set; }
        public CustomImages()
        {
            GetData data = new GetData();
            ImageList = data.GetImageSourceList();
        }
    }

    public class Company
    {
        public string Name { get; set; }

        private Location _location;
        public Location Location
        {
            get { return _location??( _location=new Location()); }set{_location=value; }
        }
    }

    public class Location
    {
        public string Country { get; set; }
        public string City { get; set; }
        public string Phone { get; set; }
    }
    public class Contacts
    {
        public List<Company> ContactList { get; set; }

        public Contacts()
        {
            GetData data = new GetData();
            ContactList = data.GetContactsList();
        }

    }
    
}
